=== debian/changelog ===
clementine (0.6-0ubuntu7) natty; urgency=low

  * Rebuild with libindicate-qt 0.2.5.91-0ubuntu2 to fix dependency

 -- Jonathan Riddell <jriddell@ubuntu.com>  Wed, 09 Feb 2011 13:38:12 +0000

clementine (0.6-0ubuntu6) natty; urgency=low

  * Build against libindicate-qt 0.2.5.91 for soname transition

 -- Jonathan Riddell <jriddell@ubuntu.com>  Mon, 07 Feb 2011 18:00:25 +0000

clementine (0.6-0ubuntu5) natty; urgency=low

  * debian/patches/ftbfs_armel.patch: Update to get fix properly.

 -- Artur Rona <ari-tczew@ubuntu.com>  Sat, 15 Jan 2011 18:25:16 +0100

clementine (0.6-0ubuntu4) natty; urgency=low

  * debian/patches/fix_two_instances.patch:
    - Update DEP3 tags.
  * debian/patches/show_full_filename_in_osd.patch:
    - Don't strip off file extensions in the OSD.
  * debian/patches/parsing_non-ascii_filenames.patch:
    - Fix parsing non-ascii filenames passed on the commandline
      (or through a file browser). (LP: #694423)
  * debian/patches/disable_lyric_providers.patch:
    - Make it possible to disable all lyric providers. (LP: #694491)

 -- Artur Rona <ari-tczew@ubuntu.com>  Sun, 26 Dec 2010 22:43:44 +0100

clementine (0.6-0ubuntu3) natty; urgency=low

  * debian/patches/fix_two_instances.patch: Fix a race condition
    on startup that might lead to two instances of Clementine being
    started. (LP: #694118)

 -- Artur Rona <ari-tczew@ubuntu.com>  Sun, 26 Dec 2010 01:09:13 +0100

clementine (0.6-0ubuntu2) natty; urgency=low

  * debian/patches/ftbfs_armel.patch: Fix FTBFS on armel.

 -- Artur Rona <ari-tczew@ubuntu.com>  Tue, 14 Dec 2010 21:34:48 +0100

clementine (0.6-0ubuntu1) natty; urgency=low

  [ Artur Rona ]
  * Initial Release (LP: #549009).

  [ Rickard Närström ]
  * debian/clementine.1: Manpages.

  [ David Sansome ]
  * debian/copyright: As upstream author, clarify licenses.

 -- Artur Rona <ari-tczew@ubuntu.com>  Sun, 12 Dec 2010 11:32:03 +0100
